#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "main.h"


extern GtkWidget *app1;

void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
   gchar *a;
   const gchar * authors[2];
   a=g_strdup(_("Anton V. Boyarshinov"));
   authors[0]=a;
   authors[1]=NULL;
   gtk_widget_show( gnome_about_new(_("Gnome Fast Read"),
		   VERSION,
		   _("(C) 2000 Anton V. Boyarshinov"),
		   authors,
		   _("Gnome application for fast reading from screen"),
		   NULL));

}





void
on_stop1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  app_stop();
}





void
app_mn_quit                            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  app_bt_quit((GtkButton*) NULL,(gpointer) NULL);
}


void
app_bt_quit                            (GtkButton       *button,
                                        gpointer         user_data)
{
  app_save_prefs();
  gtk_main_quit();
}



void
on_increase1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  app_font_increase();
}


void
on_decrease1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  app_font_decrease();
}


void
on_open_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  app_stop();
  app_file_open();
}


void
on_bt_open_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  app_stop();
  app_file_open();
}


void
on_bt_start_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  app_stop();
  app_start();
}

void
on_start1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  app_stop();
  app_start();
}




void
on_bt_font_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  app_stop();
  app_select_font();
}

void
on_font1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  app_stop();
  app_select_font();
}







void
on_bt_stop_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
app_stop();
}


void
on_bt_increase_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  app_font_increase();
}


void
on_bt_decrease_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  app_font_decrease();
}


void
on_select_all_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkText *text1;
  gint len;
  app_stop();
  text1=GTK_TEXT(lookup_widget(GTK_WIDGET(app1),"text1"));
  len=gtk_text_get_length(text1);
  gtk_editable_select_region(GTK_EDITABLE(text1),0,len);

}



void
on_cut1_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
 GtkText *text1;
 app_stop();
  text1=GTK_TEXT(lookup_widget(GTK_WIDGET(app1),"text1"));
  gtk_editable_cut_clipboard(GTK_EDITABLE(text1));
}


void
on_copy1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
GtkText *text1;
app_stop(); 
  text1=GTK_TEXT(lookup_widget(GTK_WIDGET(app1),"text1"));
  gtk_editable_copy_clipboard(GTK_EDITABLE(text1));
}


void
on_paste1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
GtkText *text1;
  text1=GTK_TEXT(lookup_widget(GTK_WIDGET(app1),"text1"));
  gtk_editable_paste_clipboard(GTK_EDITABLE(text1));
}


void
on_clear1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
GtkText *text1;
app_stop(); 
  text1=GTK_TEXT(lookup_widget(GTK_WIDGET(app1),"text1"));
  gtk_editable_delete_selection(GTK_EDITABLE(text1));
}



