/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include <sys/stat.h>
#include <fcntl.h>
#include <gnome.h>

#include <unistd.h>
#include <string.h>
#include "interface.h"
#include "support.h"

GtkText *text1;
GtkRange* vscale;
GnomeCanvas *canvas1;
GtkWidget *app1;
GtkWidget *file_selector;
guchar *fname;
GdkFont* font;
GnomeCanvasItem *item;
guchar* font_name;
gchar *buf;
GList *words=NULL;
gfloat font_hei;
gboolean go;

void app_save_prefs()
{
  GtkAdjustment* adj;
  gfloat speed;
  adj=gtk_range_get_adjustment(vscale);
  speed=adj->value;  
  gnome_config_set_float("GFastRead/Speed/Speed",speed);
  gnome_config_sync();  
}

void app_font_increase ()
{
  guchar foundary[32],famaly[32],weight[16],slant,width[16],add[32];
  guchar spacing,registry[32],encoding[16];
  guchar pixel[8],point[8],resX[8],resY[8],awidth[8];
  gint ipoint;
  sscanf(font_name,"-%[^-]-%[^-]-%[^-]-%c-%[^-]-%[^-]-%[^-]-%[^-]-%[^-]-%[^-]-%c-%[^-]-%[^-]-%s",
	foundary, famaly,weight,&slant,width,add,
	 pixel,point,resX,resY,&spacing,awidth,
	 registry,encoding);

    ipoint=atoi(point)+20; 
    font_hei=ipoint/10;
  g_free(font_name);
  font_name=g_strdup_printf("-%s-%s-%s-%c-%s-%s-%s-%d-%s-%s-%c-%s-%s-%s",
	foundary, famaly,weight,slant,width,add,
	 pixel,ipoint,resX,resY,spacing,awidth,
	 registry,encoding);
  gnome_config_set_string("GFastRead/Fonts/Font",font_name);
  gnome_config_sync();
  font=gdk_font_load(font_name);
}

void app_font_decrease ()
{  guchar foundary[32],famaly[32],weight[16],slant,width[16],add[32];
  guchar spacing,registry[32],encoding[16];
  guchar pixel[8],point[8],resX[8],resY[8],awidth[8];
  gint ipoint;
  sscanf(font_name,"-%[^-]-%[^-]-%[^-]-%c-%[^-]-%[^-]-%[^-]-%[^-]-%[^-]-%[^-]-%c-%[^-]-%[^-]-%s",
	foundary, famaly,weight,&slant,width,add,
	 pixel,point,resX,resY,&spacing,awidth,
	 registry,encoding);

    ipoint=atoi(point)-20;
    font_hei=ipoint/10;
  g_free(font_name);
  font_name=g_strdup_printf("-%s-%s-%s-%c-%s-%s-%s-%d-%s-%s-%c-%s-%s-%s",
	foundary, famaly,weight,slant,width,add,
	 pixel,ipoint,resX,resY,spacing,awidth,
	 registry,encoding);
  gnome_config_set_string("GFastRead/Fonts/Font",font_name);
  gnome_config_sync();
  font=gdk_font_load(font_name);
}

void app_font_sel_ok (GtkWidget	*w, GtkWidget *fsel)
{
  gchar point[8],dummy[32],c_dummy;
  font_name=gtk_font_selection_dialog_get_font_name (GTK_FONT_SELECTION_DIALOG(fsel));
  gnome_config_set_string("GFastRead/Fonts/Font",font_name);
  gnome_config_sync();
  sscanf(font_name,"-%[^-]-%[^-]-%[^-]-%c-%[^-]-%[^-]-%[^-]-%[^-]-%[^-]-%[^-]-%c-%[^-]-%[^-]-%s",
	dummy, dummy,dummy,&c_dummy,dummy,dummy,
	 dummy,point,dummy,dummy,&c_dummy,dummy,
	 dummy,dummy);
  
  font_hei=atoi(point)/10;
  font=gdk_font_load(font_name);
  gtk_widget_destroy (fsel);
}

void app_font_sel_cancel (GtkWidget *w, GtkWidget *fsel)
{
  gtk_widget_destroy (fsel);
}


void app_select_font()
{
  GtkWidget *fs;
    fs = gtk_font_selection_dialog_new("Font");
    gtk_font_selection_dialog_set_font_name(GTK_FONT_SELECTION_DIALOG(fs), 
					    font_name);
    
    gtk_signal_connect(GTK_OBJECT(GTK_FONT_SELECTION_DIALOG(fs)->ok_button), "clicked",
		       GTK_SIGNAL_FUNC(app_font_sel_ok), fs);
    
    gtk_signal_connect(GTK_OBJECT(GTK_FONT_SELECTION_DIALOG(fs)->cancel_button), "clicked",
		       GTK_SIGNAL_FUNC(app_font_sel_cancel), fs);
    gtk_widget_show(fs);
}

void app_vis(gboolean bool)
{
  GtkWidget *bt_open,*bt_font,*bt_increase,*bt_decrease,*bt_stop,*bt_start;
  GtkWidget *start1,*open,*font1,*increase1,*decrease1,*stop1;

  open=lookup_widget(GTK_WIDGET(app1),"open");
  gtk_widget_set_sensitive(open,bool);
  font1=lookup_widget(GTK_WIDGET(app1),"font1");
  gtk_widget_set_sensitive(font1,bool);
  increase1=lookup_widget(GTK_WIDGET(app1),"increase1");
  gtk_widget_set_sensitive(increase1,bool);
  decrease1=lookup_widget(GTK_WIDGET(app1),"decrease1");
  gtk_widget_set_sensitive(decrease1,bool);
  start1=lookup_widget(GTK_WIDGET(app1),"start1");
  gtk_widget_set_sensitive(start1,bool);
  stop1=lookup_widget(GTK_WIDGET(app1),"stop1");
  gtk_widget_set_sensitive(stop1,!bool);


  bt_start=lookup_widget(GTK_WIDGET(app1),"bt_start");
  gtk_widget_set_sensitive(bt_start,bool);
  bt_open=lookup_widget(GTK_WIDGET(app1),"bt_open");
  gtk_widget_set_sensitive(bt_open,bool);
  bt_font=lookup_widget(GTK_WIDGET(app1),"bt_font");
  gtk_widget_set_sensitive(bt_font,bool);
  bt_increase=lookup_widget(GTK_WIDGET(app1),"bt_increase");
  gtk_widget_set_sensitive(bt_increase,bool);
  bt_decrease=lookup_widget(GTK_WIDGET(app1),"bt_decrease");
  gtk_widget_set_sensitive(bt_decrease,bool);
  bt_stop=lookup_widget(GTK_WIDGET(app1),"bt_stop");
  gtk_widget_set_sensitive(bt_stop,!bool);

}

void app_stop()
{
   app_vis(TRUE);
   go=FALSE;
}

void app_emit()
{
   fprintf(stderr,"p-2\n");
   gtk_signal_emit_by_name(GTK_OBJECT(canvas1),"button_press_event");
  fprintf(stderr,"p-1\n");
}

gboolean app_word_show(gpointer dummy)
{
  GtkAdjustment* adj;
  guchar *word;
  gint len,sel,pos,end;
  gfloat speed,punct=1;
  pos=gtk_editable_get_position(GTK_EDITABLE(text1));
  sel=GTK_EDITABLE(text1)->selection_end_pos;
  if(sel>pos)pos=sel;
  if(go==FALSE)return TRUE;
  end=strtok(NULL,"\n ")-buf;
  len=end-pos;

  adj=gtk_range_get_adjustment(vscale);
  speed=adj->value;

  gtk_text_set_point(text1, (gint)pos);
  gtk_editable_select_region(GTK_EDITABLE(text1),
			     (gint)pos,
			     (gint)end);
  word=gtk_editable_get_chars(GTK_EDITABLE(text1),
			     (gint)pos,
			     (gint)end);
  word=g_strstrip(g_strdelimit(word,"\n",' '));
  switch(word[strlen(word)-1])
    {
    case '.': {punct=2;break;}
    case '?': {punct=2;break;}
    case '!': {punct=2;break;}
    case ',': {punct=1.5;break;}
    case ':': {punct=1.5;break;}
    case ';': {punct=1.5;break;}
    default: {punct=1;break;}
    }



  if(item!=NULL)gnome_canvas_item_hide(item);
  if(item!=NULL)gtk_object_destroy(GTK_OBJECT(item));
  item=gnome_canvas_item_new(gnome_canvas_root(canvas1),
			     GNOME_TYPE_CANVAS_TEXT,
			     "font_gdk",font,
			     "y",font_hei*1.3,
			     "justification",GTK_JUSTIFY_CENTER,
			     NULL);

  if(item!=NULL)gnome_canvas_item_set(item,
			"text",word,
			NULL);
  if(item!=NULL)gnome_canvas_item_show(item);
   if(item!=NULL)gnome_canvas_item_raise_to_top(item);
   g_free(word);
  if(len<0){app_stop((GtkWidget*) NULL,(gpointer)NULL);}
else
  g_timeout_add_full(G_PRIORITY_HIGH,
		     (gint)(15*(len+20)*punct/speed),
		     app_word_show,NULL,NULL);
  //  fprintf(stderr,"%d\n", (gint)(10*(len+20)*punct/speed));
  return FALSE;
}

void app_start()
{

  gint pos,sel,len;
  app_vis(FALSE);
  go=TRUE;
  len=gtk_text_get_length(text1);
  g_free(buf);
  pos=gtk_editable_get_position(GTK_EDITABLE(text1));
  sel=GTK_EDITABLE(text1)->selection_end_pos;
  if(sel>pos)pos=sel;
     buf=gtk_editable_get_chars(GTK_EDITABLE(text1),0,len);

  words=g_list_first(words);
 
  strtok(buf+pos,"\n ");
    app_word_show((gpointer)NULL);
}


void app_store_filename(GtkFileSelection *selector, gpointer user_data)
{
 
  struct stat stats;
  FILE* fp;
  gint pos;
  pos=gtk_editable_get_position(GTK_EDITABLE(text1));
    fname = gtk_file_selection_get_filename (GTK_FILE_SELECTION(file_selector));
        if (!stat(fname, &stats) && S_ISREG(stats.st_mode))
      {
	if ((buf = g_new0 (gchar, stats.st_size + 1)) != NULL)
	  {
	    if ((fp = fopen (fname, "r")) != NULL)
	      {
		fread (buf, 1,stats.st_size ,fp);
		fclose (fp);
	      }
	  }
      }

     gtk_editable_insert_text(GTK_EDITABLE(text1),buf,stats.st_size,&pos);
     gtk_editable_set_position(GTK_EDITABLE(text1),0);
 }

void app_file_open()
{
 
    /* Create the selector */
    
    file_selector = gtk_file_selection_new("Please select a file for editing.");
    
      gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(file_selector)->ok_button), 
                              "clicked", GTK_SIGNAL_FUNC (app_store_filename), NULL); 
                            
    /* Ensure that the dialog box is destroyed when the user clicks a button. */
    
    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION(file_selector)->ok_button),
                                           "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),
                                           (gpointer) file_selector);

    gtk_signal_connect_object (GTK_OBJECT (GTK_FILE_SELECTION(file_selector)->cancel_button),
                                           "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),
                                           (gpointer) file_selector);
    
    /* Display that dialog */
    
    gtk_widget_show (file_selector);

}

int
main (int argc, char *argv[])
{
  GtkWidget *bt_stop;
  gfloat speed;
  GtkAdjustment* adj;
  gchar point[8],dummy[32],c_dummy;

#ifdef ENABLE_NLS
  bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
  textdomain (PACKAGE);
#endif

  gnome_init ("gfastread", VERSION, argc, argv);

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  app1 = create_app1 ();
  gtk_widget_show (app1);
  font_name=gnome_config_get_string("GFastRead/Fonts/Font"); 
  if(font_name==NULL)font_name=strdup(_("-*-helvetica-bold-r-normal-*-*-240-*-*-p-*-iso8859-1"));
  sscanf(font_name,"-%[^-]-%[^-]-%[^-]-%c-%[^-]-%[^-]-%[^-]-%[^-]-%[^-]-%[^-]-%c-%[^-]-%[^-]-%s",
	dummy, dummy,dummy,&c_dummy,dummy,dummy,
	 dummy,point,dummy,dummy,&c_dummy,dummy,
	 dummy,dummy);
  
  font_hei=atoi(point)/10;


  font=gdk_font_load(font_name);
  text1=GTK_TEXT(lookup_widget(GTK_WIDGET(app1),"text1"));
  canvas1=GNOME_CANVAS(lookup_widget(GTK_WIDGET(app1),"canvas1"));

  vscale=GTK_RANGE(lookup_widget(GTK_WIDGET(app1),"vscale1"));
  adj=gtk_range_get_adjustment(vscale);
  speed=gnome_config_get_float("GFastRead/Speed/Speed");
  gtk_adjustment_set_value(adj,speed);
  bt_stop=lookup_widget(GTK_WIDGET(app1),"bt_stop");
  gtk_widget_set_sensitive(bt_stop,FALSE);

  gtk_main ();
  return 0;
}

